{=====================================================================}
{                                                                     }
{ Printer Name ComboBox for Windows 95 ver 1.0.2 28/Jun/1997          }
{ http://www.kobira.co.jp/sakura/windows.htm                          }
{ author Seiji-Yasuda seiji@kobira.co.jp                              }
{                                                                     }
{ You may use it freely at your own risk in any kind of environment.  }
{                                                                     }
{=====================================================================}


unit TPrnCom;

interface

uses
  Windows, SysUtils, Classes, Controls, StdCtrls, RegCBox;

type

  TCustomPrnComboBox = class(TCustomRegistryComboBox)
  protected
    procedure Loaded; override;
  public
    constructor Create(owner: TComponent); override;
    function GetDefaultPrinter: String;
  end;

  TPrnComboBox = class(TCustomPrnComboBox)
  public
    property Text; // not published - do not store
  published
//  property Style; {Must be published before Items}
    property Color;
    property Ctl3D;
//  property DragMode;
//  property DragCursor;
//  property DropDownCount;
    property Enabled;
    property Font;
(*$IFNDEF USLIB*)
//  property ImeMode;
(*$ENDIF  USLIB*)
    property ItemHeight;
//  property Items;
//  property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
//  property PopupMenu;
    property ShowHint;
//  property Sorted;
    property TabOrder;
    property TabStop;
//  property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
//  property OnDragDrop;
//  property OnDragOver;
    property OnDrawItem;
//  property OnDropDown;
//  property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
//  property OnMeasureItem;
//  property OnStartDrag;
  end;


procedure Register;


implementation

//----------------------------------------------------
// create
constructor TCustomPrnComboBox.Create(owner: TComponent);
begin
  inherited Create(owner);
// Read list of printers:
  ListType := rcbltKeyList;
  Key := KEY_LOCAL_MACHINE;
  Path := 'System\CurrentControlSet\Control\Print\Printers';
end;

function TCustomPrnComboBox.GetDefaultPrinter: String;
var
  hd : HKEY;
  tmp : array[0..255] of Char;
  DataType: Integer;
  BufSize: Integer;
begin
  DataType := REG_NONE;
  BufSize := SizeOf(tmp);
  // get registory handle.
  if RegOpenKeyExA(
       HKEY_CURRENT_CONFIG,
       'System\CurrentControlSet\Control\Print\Printers',
       0,
       KEY_QUERY_VALUE,
       hd) <> ERROR_SUCCESS then
  begin
    result := '';
    exit;
  end;
  // free registory handle.
  if RegQueryValueEx(hd, 'Default', nil, @DataType, PByte(@tmp),
    @BufSize) = ERROR_SUCCESS then
  begin
    result := tmp;
  end
  else
    result := '';
  RegCloseKey( hd );
end;

procedure TCustomPrnComboBox.Loaded;
var
  i: Integer;
begin
  inherited;
// Delete MS Fax Rendering Subsystem:
  i := Items.IndexOf('Rendering Subsystem');
  if (i >= 0) then
    Items.Delete(i);
// Show system default printer:
  i := Items.IndexOf(GetDefaultPrinter);
  if (i >= 0) then
    ItemIndex := i;
end;



//----------------------------------------------------
// register
procedure Register;
begin
  RegisterComponents('samples', [TPrnComboBox]);
end;

end.
